#ifndef EFL_OBJECT_OVERRIDE_EO_HH
#define EFL_OBJECT_OVERRIDE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_object_override.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace object { 
struct Override;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::object::Override> : ::std::true_type {}; } }
namespace efl { namespace object { 
struct Override;
} } 

namespace eo_cxx {
namespace efl { namespace object { 
struct Override {
   static Efl_Class const* _eo_class()
   {
      return EFL_OBJECT_OVERRIDE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::object::Override() const;
   operator ::efl::object::Override&();
   operator ::efl::object::Override const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Override> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Override const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace object { 
struct Override : ::efl::eo::concrete
{
   explicit Override( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Override(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Override(Override const& other) = default;
   Override(Override&& other) = default;
   Override& operator=(Override const& other) = default;
   Override& operator=(Override&& other) = default;
   Override()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Override( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Override(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Efl_Class const* _eo_class()
   {
      return EFL_OBJECT_OVERRIDE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Override> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Override const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Override) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Override>::value, "");
} } 
#endif
